/*****************************************************************************************
 Copyright (c) 2002-2004 The UbixOS Project
 All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice, this list of
 conditions, the following disclaimer and the list of authors.  Redistributions in binary
 form must reproduce the above copyright notice, this list of conditions, the following
 disclaimer and the list of authors in the documentation and/or other materials provided
 with the distribution. Neither the name of the UbixOS Project nor the names of its
 contributors may be used to endorse or promote products derived from this software
 without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
 EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id$

*****************************************************************************************/

#include <vmm/vmm.h>
#include <ubixos/sched.h>
#include <ubixos/kpanic.h>
#include <ubixos/spinlock.h>

static spinLock_t fvpSpinLock;

/************************************************************************

Function: void *vmmGetFreeVirtualPage(pidType pid,int count);
Description: Returns A Free Page Mapped To The VM Space
Notes:

08/11/02 - This Will Return Next Avilable Free Page Of Tasks VM Space

************************************************************************/
void           *
vmmGetFreeVirtualPage(pidType pid, int count)
{
  int             x = 0, y = 0, c = 0;
  uInt32         *pageTableSrc = 0x0;
  uInt32         *pageDir = 0x0;
  
  spinLock(&fvpSpinLock);
  
  pageDir = (uInt32 *) parentPageDirAddr;

  /* Lets Search For A Free Page */
  if (_current->oInfo.vmStart <= 0x100000)
    kpanic("Invalid vmStart\n");
  for (x = (_current->oInfo.vmStart / (1024 * 4096)); x < 1024; x++) {
    /* Set Page Table Address */
    if ((pageDir[x] & PAGE_PRESENT) != PAGE_PRESENT) {
      /* If Page Table Is Non Existant Then Set It Up */
      pageDir[x] = (uInt32) vmmFindFreePage(_current->id) | PAGE_DEFAULT;
      /* Also Add It To Virtual Space So We Can Make Changes Later */
      pageTableSrc = (uInt32 *) (tablesBaseAddress + (4096 * 767));
      pageTableSrc[x] = pageDir[x];
      y = 1;
      /* Reload Page Directory */
      asm(
	  "movl %cr3,%eax\n"
	  "movl %eax,%cr3\n"
	);
    }
    pageTableSrc = (uInt32 *) (tablesBaseAddress + (0x1000 * x));
    if (y != 0x0) {
      for (y = 0x0;y<pageEntries;y++) {
        pageTableSrc[y] = (uInt32)0x0;
        }
      }
    for (y = 0; y < 1024; y++) {
      /* Loop Through The Page Table Find An UnAllocated Page */
      if ((uInt32) pageTableSrc[y] == (uInt32) 0x0) {
	if (count > 0x1) {
          for (c = 0; c < count; c++) {
            if (y + c < 1024) {
              if ((uInt32) pageTableSrc[y + c] != (uInt32) 0x0) {
                c = -1;
                break;
                }
              }
            }
	  if (c != -1) {
	    for (c = 0; c < count; c++) {
	      if ((vmm_remapPage((uInt32) vmmFindFreePage(pid), ((x * (1024 * 4096)) + ((y + c) * 4096)),PAGE_DEFAULT)) == 0x0)
	        kpanic("vmmRemapPage: getFreeVirtualPage-1: [0x%X]\n",((x * (1024 * 4096)) + ((y + c) * 4096)));
	      vmmClearVirtualPage((uInt32) ((x * (1024 * 4096)) + ((y + c) * 4096)));
	    }
	    spinUnlock(&fvpSpinLock);
	    return ((void *)((x * (1024 * 4096)) + (y * 4096)));
	  }
	} else {
	  /* Map A Physical Page To The Virtual Page */

	  /*
	   * remapPage((uInt32)vmmFindFreePage(pid),((x*(1024*4096))+(y*4096))
	   * ,pid);
	   */
	  if ((vmm_remapPage((uInt32) vmmFindFreePage(pid), ((x * (1024 * 4096)) + (y * 4096)),PAGE_DEFAULT)) == 0x0)
	    kpanic("vmmRemapPage: getFreeVirtualPage-2\n");
	  /* Clear This Page So No Garbage Is There */
	  vmmClearVirtualPage((uInt32) ((x * (1024 * 4096)) + (y * 4096)));
	  /* Return The Address Of The Newly Allocate Page */
	  spinUnlock(&fvpSpinLock);
	  return ((void *)((x * (1024 * 4096)) + (y * 4096)));
	}
      }
    }
  }
  /* If No Free Page Was Found Return NULL */
  spinUnlock(&fvpSpinLock);
  return (0x0);
}

/***
 $Log$
 Revision 1.6  2005/08/09 08:45:40  fsdfs
 reverting to old vmm. i may have modified something accidently when i wasted time indenting the code.

 Revision 1.4  2004/07/28 15:05:43  reddawg
 Major:
   Pages now have strict security enforcement.
   Many null dereferences have been resolved.
   When apps loaded permissions set for pages rw and ro

 Revision 1.3  2004/07/28 00:17:05  reddawg
 Major:
   Disconnected page 0x0 from the system... Unfortunately this broke many things
   all of which have been fixed. This was good because nothing deferences NULL
   any more.

 Things affected:
   malloc,kmalloc,getfreepage,getfreevirtualpage,pagefault,fork,exec,ld,ld.so,exec,file

 Revision 1.2  2004/07/24 23:21:25  reddawg
 ok last of my commits for the night I'm going to bed

 Revision 1.1.1.1  2004/04/15 12:06:51  reddawg
 UbixOS v1.0

 Revision 1.10  2004/04/13 16:36:34  reddawg
 Changed our copyright, it is all now under a BSD-Style license

 END
 ***/

